<?
set_time_limit(600);

header("content-type:text/html;charset=UTF-8");

/**************functions*******************/ 

function get_product_id_by_outer($outer_product_id){
  global $mysqli;
  $stmt="select product_id from PRODUCT where outer_product_id=? ";
  $sth=$mysqli->prepare($stmt);
  $sth->bind_param("i",$outer_product_id);  
  $sth->bind_result($ret_value); 
  $sth->execute();
  if (!$row=$sth->fetch()) $ret_value="NULL";  
  $sth->close();
  return $ret_value;
  }

function ins_upd_product($PRODUCT_N, $FOTO_FILE,  $INIT_PRICE, $QTY_WRH, $ACTUAL_IF_QTY_0, $PRODUCT_N_LANG1, $CODE, $NOTES, $OUTER_PRODUCT_ID, $CATALOG_CLASS_STR){
  global $mysqli;
  $_product_id=get_product_id_by_outer($OUTER_PRODUCT_ID);
  if ($_product_id=="NULL"){
	  $GLOBALS["C_total_inserted"]++;
      $stmt="insert into PRODUCT(PRODUCT_N, FOTO_FILE,  INIT_PRICE, QTY_WRH, ACTUAL_IF_QTY_0, PRODUCT_N_LANG1, CODE, NOTES, OUTER_PRODUCT_ID, CATALOG_CLASS_STR, REG_DATE) values(?,?,?,?,?,?,?,?,?,?,CURRENT_TIMESTAMP) ";
      if (!$sth=$mysqli->prepare($stmt)) {
         printf("<b>Erorr inserting product: %s<br></b>", $mysqli->error);
	     };
      $sth->bind_param("ssddsssbis",  $PRODUCT_N, $FOTO_FILE, $INIT_PRICE, $QTY_WRH, $ACTUAL_IF_QTY_0, $PRODUCT_N_LANG1, $CODE, $NOTES, $OUTER_PRODUCT_ID, $CATALOG_CLASS_STR);
      $sth->send_long_data(7,$NOTES);
      }
  else{ 
	  $GLOBALS["C_total_updated"]++;
      $stmt="update PRODUCT set PRODUCT_N=?, FOTO_FILE=?,  INIT_PRICE=?, QTY_WRH=?, ACTUAL_IF_QTY_0=?, PRODUCT_N_LANG1=?, CODE=?, NOTES=?, OUTER_PRODUCT_ID=?, CATALOG_CLASS_STR=? where product_id=? "; 

      if (!$sth=$mysqli->prepare($stmt)) {
         printf("Erorr updating product: %s\n", $mysqli->error);
	     };

      $sth->bind_param("ssddsssbisi",  $PRODUCT_N, $FOTO_FILE,  $INIT_PRICE, $QTY_WRH, $ACTUAL_IF_QTY_0, $PRODUCT_N_LANG1, $CODE, $NOTES, $OUTER_PRODUCT_ID, $CATALOG_CLASS_STR, $_product_id);
	  $sth->send_long_data(7,$NOTES);
      }
  $sth->execute();
  $sth->close();
  }

function insert_product_tree($outer_product_id,$outer_tree_id){
  global $mysqli;
  $_product_id=get_product_id_by_outer($outer_product_id);

  if ($_product_id!="NULL"){
//	  echo " prod_id=".$_product_id." outer_tree_id=". $outer_tree_id." prod_id=". $_product_id."<br>";
      $stmt="insert into PRODUCT_TREE(tree_id,product_id) select t.tree_id,? from TREE t where t.outer_tree_id=? and not exists( select pt.product_tree_id from PRODUCT_TREE pt where pt.tree_id=t.tree_id and pt.product_id=? ) ";

      if (!$sth=$mysqli->prepare($stmt)) {
          printf("Erorr updating product: %s\n", $mysqli->error);
	      };
      $sth->bind_param("iii", $_product_id, $outer_tree_id, $_product_id);

  $sth->execute();
  $sth->close();
  }
}

function _main($url_xml){
    $xml = simplexml_load_file($url_xml);

    $result_stat=$xml->xpath("//catalogue//status");
    $result_stat_id=$result_stat[0]->status_id;
    if (($result_stat_id!=48) && ($result_stat_id!=46) && ($result_stat_id!=41) && ($result_stat_id!=42)){
	    echo "Failed : status:".$result_stat_id;
	    exit;
        }
    $result=$xml->xpath("//catalogue//product");


    foreach ($result as $second_gen) {
    
        ins_upd_product($second_gen->product_name, $second_gen->foto_url,  $second_gen->price_novat, $second_gen->qty, $second_gen->atcual_qty0, $second_gen->product_name_rus, $second_gen->code, $second_gen->description_html, $second_gen->product_id,$second_gen->classification->classif_path_str);
        }
    foreach ($result as $second_gen) {
        insert_product_tree($second_gen->product_id,$second_gen->classification->classif_id);
        }
}


function getmicrotime(){ 
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
    } 

/**************functions ends*******************/




/* PROGRAM STARTS */
$time_start = getmicrotime();
$C_total_inserted=0;
$C_total_updated=0;
/* Input variabels */  
$mysqli = new mysqli("localhost", "root", "", "ps2_mysql");
$varaint=2;
$catalogue_xml='http://www.akvedukts.lv/xml/akvedukts.xml';
$C_user_name="your name"; // use correct uname and password !!!!!!!!!!!!!!
$C_pasww="your passw";
/* End Input variabels */  

echo "Variant:".$varaint."\n";

switch ($varaint){
// variant 1 **************** product by code
  case 1:
  $url_xml="http://www.akvedukts.lv/xml/prepare_product_by_code.php?user_name=".$C_user_name."&passw=".$C_pasww."&code=11001&is_fragment=y";
  _main($url_xml);
  break;
// variant 2 **************** products by catalogue tree_id
  case 2:
   $url_xml="http://www.akvedukts.lv/xml/prepare_product_by_tree.php?user_name=".$C_user_name."&passw=".$C_pasww."&tree_name_id=5";
  _main($url_xml);
  break;



// variant 3  **************** full catalogue upper tree_id
  case 3:

   $xml = simplexml_load_file($catalogue_xml);

   $result=$xml->xpath("//node[@parent_id=2]");

   foreach ($result as $second_gen) {
     $aa=$second_gen->attributes();
     echo "id=".$aa[0]." parent_id=".$aa[1]." level=".$aa[2]. "  ".$second_gen->tree_name ." last_level=".$aa[3]."<br>";
     _main("http://www.akvedukts.lv/xml/prepare_product_by_tree.php?user_name=".$C_user_name."&passw=".$C_pasww."&tree_name_id={$aa[0]}");
     }
   break;



}// end switch 



echo "time:".(getmicrotime()-$time_start).";\n";
echo "products inserted:".$C_total_inserted.";\n";
echo "products updated:".$C_total_updated.";\n";

/* PROGRAM ENDS */

?>
